%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  ֐ : newton 
%    : 㐔܂Ƃ߂֐ equation, m̏l init
%  @\  : j[g@ɂ菉linitƂequation𐔒lIɉ
%
function y = newton(equation, init)
MAX_COUNT=100;  %ő̌vZ
EPS = 1.0e-9;   %
H = 1.0e-6;     %ϕ
flag=0;

x_init = init;
sz = size(init);

DIM=numel(init);
x_now  = ones(DIM,1);
x_new  = ones(DIM,1);
x_delta =ones(DIM,1);
func   = ones(DIM,1);
factor = ones(DIM,1);
func_h = ones(DIM);
inv_factor = ones(DIM);

%%Initializaion
x_new  = x_new*0;
%A = reshape(init,DIM,1)

x_now = reshape(init,DIM,1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for count = 1:1:MAX_COUNT
    
    %Derivation for jacobian of non-liner equation matrix
    func = equation(reshape(x_now,sz));    
    func_h(1,:);
    
    for i = 1:1:DIM
        x_now(i) = x_now(i) + H;
        func_h(:,i) = equation(reshape(x_now,sz));
        x_now(i) = x_now(i) - H;
    end
    
    for i = 1:1:DIM
        for j = 1:1:DIM
            factor(i,j) = (func_h(i,j)-func(i))/H;
        end
    end
    
    E = eye(DIM);
    A = [factor E];
    R = rref(A);
    inv_factor = R(:,DIM+1:2*DIM);          %Calculate inverse matrix
    
    
    %Calculate partical differential
    x_delta= 0 * x_delta;
    for i = 1:1:DIM
        for j = 1:1:DIM
            x_delta(i) = x_delta(i) - func(j)*inv_factor(i,j);
        end
    end
    
    %Updating values
    x_new = x_now + x_delta;
    
    %Check that convergens conditions are satisfied
    for i = 1:1:DIM
        if abs(x_new(i)-x_now(i)) < EPS
            flag = flag+1;
        end
    end
    
    if flag==DIM
        break
    else
        flag=0;
    end
    
    %Updating values for next iteration
    x_now = x_new;
end

%Output solved values
y=reshape(x_now,size(init));


end

